#define here cerr<<"===========================================\n"
#define dbg(x) cerr<<#x<<": "<<x<<endl;
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define ld double
#define ll long long
#define llinf 100000000000000000LL // 10^17
#define pb push_back
#define popb pop_back
#define fi first
#define sc second
#define endl '\n'
#define pll pair<ll,ll>
#define pld pair<ld,ld>
#define sz(a) (ll)(a.size())
#define all(a) a.begin(),a.end()
#define ceri(a,l,r) {cerr<<#a<<": ";for(ll i_ = l;i_<=r;i_++) cerr<<a[i_]<< " ";cerr<<endl;}
#define cer(a) {cerr<<#a<<": ";for(ll x_ : a) cerr<<x_<< " ";cerr<<endl;}

#define daj_mi_malo_vremena ios_base::sync_with_stdio(false);cerr.tie(0);cout.tie(0);cin.tie(0);

using namespace std;
using namespace __gnu_pbds;
/*
ll add(ll x,ll y){
    x+=y;
    if(x<0){
        x%=mod;
        x+=mod;
    }else{
        if(x>=mod) x%=mod;
    }
    return x;
}
ll mul(ll a,ll b){
	ll ans = (a*b)%mod;
	if(ans<0) ans+=mod;
	return ans;
}
typedef tree<int,null_type,less<ll>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;
typedef tree<int,null_type,less_equal<ll>,rb_tree_tag,tree_order_statistics_node_update> ordered_multiset;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll rnd(ll l,ll r){
    return uniform_int_distribution<ll>(l,r)(rng);
}
*/
#define maxn 200005
ll n,m;
vector<pll> g[maxn];
ll dp[maxn][2];
int main(){
	daj_mi_malo_vremena
    cin >> n >> m;
    for(ll i = 1;i<=m;i++){
        ll x,y,w; cin >> x >> y >> w;
        g[x].pb({y,w});
        g[y].pb({x,w});
    }
    ll st,en; cin >> st >> en;
    for(ll i = 1;i<=n;i++) for(ll j = 0;j<=1;j++) dp[i][j] = llinf;
    dp[st][0] = 0;
    priority_queue<pll> q;
    q.push({0,st});
    while(sz(q)){
        ll u = q.top().sc;
        ll r = u>0 ? 0 : 1;
        u = abs(u);
        ll cur = q.top().fi;
        q.pop();
        for(pll p : g[u]){
            ll s = p.fi; ll w = p.sc;
            if(cur + (r!=w) < dp[s][w]){
                dp[s][w] = cur + (r!=w);
                ll k = s;
                if(w) k = -s;
                q.push({dp[s][w],k});
            }
        }
    }
    ll ans = min(dp[en][0],dp[en][1]);
    if(ans==llinf) ans = -1;
    cout<<ans<<endl;
	return 0;
}